Add item to cart - Fabric

Add item to cart

Example cURL Command

curl --request POST \
  --url https://prod01-apigw.yourcompany.fabric.zone/api-cart/cart/item \
  --header 'Content-Type: application/json' \
  --header 'x-site-context: <x-site-context>' \
  --data '
{
  "cartId": "123456abcdef123456abcdef",
  "items": [
    {
      "itemId": 1000000012,
      "quantity": 2,
      "price": {
        "currency": "USD",
        "base": 15.99,
        "discount": {
          "price": 10.99,
          "discountAmount": 10.99,
          "promosApplied": [
            {
              "unit": "<string>",
              "value": 123,
              "ON": {
                "kind": "SKU",
                "value": ""
              },
              "id": "<string>",
              "promoId": "<string>",
              "promoCode": "<string>"
            }
          ]
        },
        "sale": 10.99
      },
      "group": [
        "5ddd1a156c5a5fed1e0d91fb"
      ],
      "priceListId": 100002,
      "isUnique": 123,
      "extra": {}
    }
  ],
  "userAuthToken": "JWT",
  "company": "Fabric Inc."
}
'

Python Example

import requests

url = "https://prod01-apigw.yourcompany.fabric.zone/api-cart/cart/item"

payload = {
    "cartId": "123456abcdef123456abcdef",
    "items": [
        {
            "itemId": 1000000012,
            "quantity": 2,
            "price": {
                "currency": "USD",
                "base": 15.99,
                "discount": {
                    "price": 10.99,
                    "discountAmount": 10.99,
                    "promosApplied": [
                        {
                            "unit": "<string>",
                            "value": 123,
                            "ON": {
                                "kind": "SKU",
                                "value": ""
                            },
                            "id": "<string>",
                            "promoId": "<string>",
                            "promoCode": "<string>"
                        }
                    ]
                },
                "sale": 10.99
            },
            "group": ["5ddd1a156c5a5fed1e0d91fb"],
            "priceListId": 100002,
            "isUnique": 123,
            "extra": {}
        }
    ],
    "userAuthToken": "JWT",
    "company": "Fabric Inc."
}
headers = {
    "x-site-context": "<x-site-context>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

Node.js Example

const options = {
  method: 'POST',
  headers: {'x-site-context': '<x-site-context>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    cartId: '123456abcdef123456abcdef',
    items: [{
      itemId: 1000000012,
      quantity: 2,
      price: {
        currency: 'USD',
        base: 15.99,
        discount: {
          price: 10.99,
          discountAmount: 10.99,
          promosApplied: [{
            unit: '<string>',
            value: 123,
            ON: {kind: 'SKU', value: ''},
            id: '<string>',
            promoId: '<string>',
            promoCode: '<string>'
          }]
        },
        sale: 10.99
      },
      group: ['5ddd1a156c5a5fed1e0d91fb'],
      priceListId: 100002,
      isUnique: 123,
      extra: {}
    }],
    userAuthToken: 'JWT',
    company: 'Fabric Inc.'
  })
};

fetch('https://prod01-apigw.yourcompany.fabric.zone/api-cart/cart/item', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP Example

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://prod01-apigw.yourcompany.fabric.zone/api-cart/cart/item",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'cartId' => '123456abcdef123456abcdef',
    'items' => [[
        'itemId' => 1000000012,
        'quantity' => 2,
        'price' => [
            'currency' => 'USD',
            'base' => 15.99,
            'discount' => [
                'price' => 10.99,
                'discountAmount' => 10.99,
                'promosApplied' => [[
                    'unit' => '<string>',
                    'value' => 123,
                    'ON' => ['kind' => 'SKU', 'value' => ''],
                    'id' => '<string>',
                    'promoId' => '<string>',
                    'promoCode' => '<string>'
                ]]
            ],
            'sale' => 10.99
        ],
        'group' => ['5ddd1a156c5a5fed1e0d91fb'],
        'priceListId' => 100002,
        'isUnique' => 123,
        'extra' => []
    ]],
    'userAuthToken' => 'JWT',
    'company' => 'Fabric Inc.'
]),
  CURLOPT_HTTPHEADER => [
    "Content-Type: application/json",
    "x-site-context: <x-site-context>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Response Example

{
  "deleted": false,
  "allPromosApplied": [{
    "unit": "<string>",
    "value": 123,
    "ON": {
      "kind": "SKU",
      "value": ""
    },
    "id": "<string>",
    "promoId": "<string>",
    "promoCode": "<string>"
  }],
  "items": [{
    "itemId": 1000000012,
    "quantity": 2,
    "price": {
      "currency": "USD",
      "base": 15.99,
      "discount": {
        "price": 10.99,
        "discountAmount": 10.99,
        "promosApplied": [{
          "unit": "<string>",
          "value": 123,
          "ON": {
            "kind": "SKU",
            "value": ""
          },
          "id": "<string>",
          "promoId": "<string>",
          "promoCode": "<string>"
        }]
      },
      "sale": 10.99
    },
    "group": ["5ddd1a156c5a5fed1e0d91fb"],
    "priceListId": 100002,
    "isUnique": 123,
    "discountedQuantity": 0,
    "lineItemId": 1,
    "totalPrice": {
      "currency": "USD",
      "amount": 200
    },
    "id": "5fee9d59f2f08a1b3cbdea08",
    "sample": false,
    "weightUnit": "kg",
    "isPickup": false,
    "sku": "blue",
    "taxCode": "PH0607",
    "title": "item title",
    "weight": 7,
    "attributeTotalPrice": 0,
    "attributes": [{
      "price": 10,
      "_id": "6146e98408e3700008b64611",
      "attributeId": "60a77de306f682000975c24c",
      "value": "true/false",
      "name": "Gift Message",
      "type": "<string>",
      "id": "6146e98408e3700008b64611"
    }],
    "_id": "5fee9d59f2f08a1b3cbdea08",
    "createdAt": "2020-12-31T02:09:53.914Z",
    "updatedAt": "2020-12-31T02:09:53.914Z"
  }],
  "registeredUser": false,
  "cartId": 4,
  "totalAmmount": {
    "currency": "USD",
    "amount": 200
  },
  "quantity": 2,
  "__v": 0,
  "attributes": [{
    "price": 10,
    "_id": "6146e98408e3700008b64611",
    "attributeId": "60a77de306f682000975c24c",
    "value": "true/false",
    "name": "Gift Message",
    "type": "<string>",
    "id": "6146e98408e3700008b64611"
  }],
  "account": "<string>",
  "approver": "<string>",
  "po": "<string>",
  "company": "<string>",
  "status": "pending",
  "extra": {},
  "errors": {
    "inventory": "<array>",
    "price": "<array>",
    "promo": "<array>"
  },
  "_id": "5fee9d59f2f08a1b3cbdea08",
  "createdAt": "2020-12-31T02:09:53.914Z",
  "updatedAt": "2020-12-31T02:09:53.914Z"
}

Possible Error Responses

{
  "code": "INVALID_AUTHORIZATION_TOKEN",
  "message": "Invalid Authorization Token"
}
{
  "code": "NOT_IN_STOCK",
  "message": "ItemIds 170 are not in stock."
}

Headers